/***************************************************************************
 ***        Programm zur Ansteuerung der PC-Karte                        ***
 ***                    IO 1213                                          ***
 ***************************************************************************/

#include <stdio.h>           /* Prototypen fr Ein-Ausgabe */
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <string.h>

void clear_screen(void);
void write_position(int x, int y, char *text, int attr);

unsigned char key=0;
unsigned char fehler=0;
unsigned char kartentyp=0;
unsigned char port[6]={0,0,0,0,0,0};
unsigned char state[6]={0,0,0,0,0,0};
unsigned ausgaenge=0;
unsigned int  adresse=0x100;

/************************************************************************
 ***                Hauptprogramm                                     ***
 ************************************************************************/

int main(int argc, char *argv[])
{
  int i,k;
  char cx,cy;

  if(argc!=2)
    fehler=1;
  else
    {
      /* Parameter prfen */
      if(strcmp(argv[1],"01")==0)
	kartentyp=1;
      else
	if(strcmp(argv[1],"02")==0)
	  kartentyp=2;
	else
	  if(strcmp(argv[1],"03")==0)
	    kartentyp=3;
	  else
	    if(strcmp(argv[1],"04")==0)
	      kartentyp=4;
	    else
	      if(strcmp(argv[1],"05")==0)
		kartentyp=5;
	      else
		if(strcmp(argv[1],"06")==0)
		  kartentyp=6;
		else
		  if(strcmp(argv[1],"07")==0)
		    kartentyp=7;
		  else
		    fehler=1;

      /* Wenn Aufruf korrekt */
      if(!fehler)
	{
	  /* IO 1213 initialisieren */
	  switch(kartentyp)
	    {
	      case 1:
		{
		  /* IO 1213 / 01 */
		  outportb(adresse+3,0x80);
		  outportb(adresse+7,0x80);
		  port[0]=port[1]=port[2]=port[3]=port[4]=port[5]=1;
		  break;
		}
	      case 2:
		{
		  /* IO 1213 / 02 */
		  outportb(adresse+3,0x89);
		  outportb(adresse+7,0x80);
		  port[0]=port[1]=port[3]=port[4]=port[5]=1;  /* Ausgaenge */
		  break;
		}
	      case 3:
		{
		  /* IO 1213 /03 */
		  outportb(adresse+3,0x8B);
		  outportb(adresse+7,0x80);
		  port[0]=port[3]=port[4]=port[5]=1;
		  break;
		}
	      case 4:
		{
		  /* IO1213 / 04 */
		  outportb(adresse+3,0x9B);
		  outportb(adresse+7,0x80);
		  port[3]=port[4]=port[5]=1;
		  break;
		}
	      case 5:
		{
		  /* IO 1213 / 05 */
		  outportb(adresse+3,0x9B);
		  outportb(adresse+7,0x82);
		  port[3]=port[5]=1;
		  break;
		}
	      case 6:
		{
		  /* IO 1213 / 06 */
		  outportb(adresse+3,0x9B);
		  outportb(adresse+7,0x92);
		  port[5]=1;
		  break;
		}
	      case 7:
		{
		  /* IO 1213 / 07 */
		  outportb(adresse+3,0x9B);
		  outportb(adresse+7,0x9B);
		  break;
		}
	    }
	  /* Ausgaenge auf 0 setzen */
	  for(i=0;i<6;i++)
	    if(port[i]==1)
	      {
		ausgaenge=1;
		cx=0;
		cy=5;
		if(i>2)
		  outportb(adresse+1+i,0);
		else
		  outportb(adresse+i,0);
	      }

	  /* Bildschirm initialisieren */
	  clear_screen();                       /* Bildschirm lschen           */
	  _setcursortype(_NOCURSOR);

	  /* Tasten auswerten */
	  key=0;                                /* Variable fr Taste initialisieren */
	  do                                    /* in Schleife verharren        */
	    {                                   /* bis Taste           gedrckt */
	      if(kbhit())                       /* Ist Taste gedrckt ?         */
		{                               /* Wenn ja, dann                */
		  key=getch();                  /* ASCII-Wert lesen             */
		  if(key==0)
		    {
		      /* Funktionstaste -> Scan-Code auswerten */
		      key=getch();              /* Scan-Code holen              */
		      if(ausgaenge)             /* Nur auswerten, wenn Ausgaenge vorhanden sind */
			switch (key)
			  {
			    case 72 :
			      {
				/* Cursor hoch */
				if(cy>0)
				  {
				    for(i=cy-1;i>=0;i--)
				      {
					if(port[i]==1)
					  {
					    cy=i;
					    break;
					  }
				      }
				    if(i<0)
				      printf("\a");
				  }
				else
				  printf("\a");
				break;
			      }
			    case 80 :
			      {
				/* Cursor runter */
				if(cy<5)
				  {
				    for(i=cy+1;i<6;i++)
				      {
					if(port[i]==1)
					  {
					    cy=i;
					    break;
					  }
				      }
				    if(i==6)
				      printf("\a");
				  }
				else
				  printf("\a");
				break;
			      }
			    case 77 :
			      {
				/* Cursor rechts */
				if(cx>0)
				  cx--;
				else
				  printf("\a");
				break;
			      }
			    case 75 :
			      {
				/* Cursor links */
				if(cx<7)
				  cx++;
				else
				  printf("\a");
				break;
			      }
			  }
		    }
		  else
		    {
		      /* Einfache Zeichentaste wurde bettigt */
		      if(ausgaenge)
			switch(key)
			  {
			    case 13 :    /* Taste Return/Enter */
			    case 32 :    /* Taste Space */
			      {
				/* Ausgabebit invertieren auf der der Cursor steht*/
				state[cy]=state[cy] ^ (1 << cx);
				/* An Karte ausgeben */
				if(cy>2)
				  outportb(adresse+1+cy,state[cy]);
				else
				  outportb(adresse+cy,state[cy]);
				break;
			      }
			  }
		    }
		}
	      /* Eingaenge lesen */
	      for(i=0;i<6;i++)
		if(port[i]==0)
		  {
		    if(i>2)
		      state[i]=inportb(adresse+1+i) ^ 255;  /* Ergebnis invertieren */
		    else                                    /* (bedingt durch Optokoppler) */
		      state[i]=inportb(adresse+i) ^ 255;
		  }
	      /* Werte auf dem Bildschirm in der Tabelle darstellen */
	      for(i=0;i<6;i++)        /* Alle 6 Ports */
		for(k=0;k<8;k++)      /* Jeweils alle 8 Bit */
		  {
		    if((cy==i) && (cx==k))
		      textattr(0x2A);  /* Darstellung Cursor */
		    else
		      textattr(0x7E);  /* Darstellung normaler Eintrag */
		    if((state[i] & (1 << k))==0)
		      {
			gotoxy(54-(4*k),11+(2*i));
			cprintf(" 0 ");
		      }
		    else
		      {
			gotoxy(54-(4*k),11+(2*i));
			cprintf(" 1 ");
		      }
		  }
	    }
	  while (key!=68);                      /* Wenn F10, dann ende          */
	  textattr(0x07);
	  clrscr();
	  for(i=0;i<6;i++)
	    if(port[i]==1)
	      if(i>2)
		outportb(adresse+1+i,0);
	      else
		outportb(adresse+i,0);
	  _setcursortype(_NORMALCURSOR);        /* Standardcursor an            */
	}
     }
  /* Sollte beim Aufruf ein Fehler aufgetreten sein, wird eine Aufrufhilfe
	  auf dem Bildschirm ausgegeben */
  if(fehler)
    {
      printf("\n\r\n\r Aufruf mit : IO1213 xx");
      printf("\n\r wobei fr xx der Typ der Karte einzusetzen ist. \n\r Folgende Werte knnen eingesetzt werden :");
      printf("\n\r   01 -> IO 1213 / 01");
      printf("\n\r   02 -> IO 1213 / 02");
      printf("\n\r   03 -> IO 1213 / 03");
      printf("\n\r   04 -> IO 1213 / 04");
      printf("\n\r   05 -> IO 1213 / 05");
      printf("\n\r   06 -> IO 1213 / 06");
      printf("\n\r   07 -> IO 1213 / 07\n\r\n\r");
    }
  return 0;
}

/************************************************************************
 ***                Unterprogramme zur Bildschirmsteuerung            ***
 ************************************************************************/

void clear_screen(void)
{
  /* Diese Funktion dient zum lschen des Bildschirmes, sowie dessen
	  Einstellung. Der Hintergrund wird auf die Farbe Blau eingestellt.
	  Es wird des weiteren ein Fenster mit der Firmenadresse dargestellt.  */

  /* Fenster 1 */
  char rahm1[]="ͻ";
  char rahm2[]="                                                         ";
  char rahm3[]="ͼ";
  char text1[]=" ERMA-Electronic GmbH, Max-Eyth-Str. 8, 78194 Immendingen";
  char text2[]="      Tel. 07462/7381               Fax 07462/7554       ";
  char text3[]="";

  /* Fenster 2 */
  char rahm21[]="ͻ";
  char rahm22[]="                                                         ";
  char rahm23[]=" F10 = ENDE ͼ";
  char zeile1[]="Ŀ";
  char zeile2[]="Ĵ";
  char zeile3[]="";
  char text20[]="    Bit     7   6   5   4   3   2   1   0";
  char text21[]=" Port A1                                  ";
  char text22[]=" Port B1                                  ";
  char text23[]=" Port C1                                  ";
  char text24[]=" Port A2                                  ";
  char text25[]=" Port B2                                  ";
  char text26[]=" Port C2                                  ";

  char x;

  textbackground(BLUE);                 /* Hintergrundfarbe schwarz     */
  textcolor(CYAN);                      /* Vordergrundfarbe hellgrau    */
  clrscr();                             /* Bildschirm lschen           */

  /* Erzeugen eines Fensters */
  gotoxy(12,2);
  textattr(0x7F);
  cprintf(rahm1);
  gotoxy(12,3);
  cprintf(rahm2);
  gotoxy(12,4);
  cprintf(rahm2);
  gotoxy(12,5);
  cprintf(rahm3);
  /* Erzeugen des Fenstertextes */
  textattr(0x70);
  gotoxy(13,3);
  cprintf(text1);
  gotoxy(13,4);
  cprintf(text2);
  /* Erzeugen des Fensterschattens */
  gotoxy(13,6);
  cprintf(text3);
  gotoxy(71,3);
  cprintf("");
  gotoxy(71,4);
  cprintf("");
  gotoxy(71,5);
  cprintf("");
  textattr(0x03);

  /* Erzeugen des Ausgabefensters */
  gotoxy(12,8);
  textattr(0x7F);
  cprintf(rahm21);
  for(x=9;x<23;x++)
    {
      gotoxy(12,x);
      cprintf(rahm22);
    }
  gotoxy(12,x++);
  cprintf(rahm23);
  /* Erzeugen des Fensterschattens */
  textattr(0x70);
  gotoxy(13,x++);
  cprintf(text3);
  for(x=9;x<24;x++)
    {
      gotoxy(71,x);
      cprintf("");
    }
  gotoxy(71,x++);
  cprintf("");
  textattr(0x03);
  /* Erzeugen des Fenstertextes */
  textattr(0x70);
  gotoxy(15,9);
  cprintf(text20);
  gotoxy(15,10);
  cprintf(zeile1);
  gotoxy(15,11);
  cprintf(text21);
  gotoxy(15,12);
  cprintf(zeile2);
  gotoxy(15,13);
  cprintf(text22);
  gotoxy(15,14);
  cprintf(zeile2);
  gotoxy(15,15);
  cprintf(text23);
  gotoxy(15,16);
  cprintf(zeile2);
  gotoxy(15,17);
  cprintf(text24);
  gotoxy(15,18);
  cprintf(zeile2);
  gotoxy(15,19);
  cprintf(text25);
  gotoxy(15,20);
  cprintf(zeile2);
  gotoxy(15,21);
  cprintf(text26);
  gotoxy(15,22);
  cprintf(zeile3);
  /* Konfiguration eintragen */
  for(x=0;x<6;x++)
    {
      gotoxy(59,11+(2*x));
      if(port[x]==0)
	{
	  textattr(0x74);
	  cprintf("Eingang");
	}
      else
	{
	  textattr(0x7A);
	  cprintf("Ausgang");
	}
    }
}

/***************************************************************************/

void write_position(int x,int y,char *text,int attr)
{
  if (attr==0)
    textattr(0x10);
  if (attr==1)
    textattr(0x3E);
  gotoxy(x,y);
  cprintf(text);

}
